<template>
  <q-page class="q-ma-xl">
    <!--if there is no selected row then the form submits at addTodo, else it submits at updateTodo-->
    <q-form @submit="!selectedRow.id ? addTodo() : updateTodo()" class="q-ma-md">
      <q-input v-model="form.title" label="Input Field"/>
      <!--This button concerns the submitting of new todo items-->
      <q-btn 
        type="submit" 
        label="Submit" 
        color="primary"
      />
      <!--This button concerns the deletion of todo items-->
      <q-btn
        :loading="deleteBtnLoadingState"
        v-if="selectedRow.id"
        @click="deleteTodo()"
        class="q-ml-md"
        label="Delete"
        color="negative"
      />
    </q-form>
    <!--This table is where our todo list gets displayed. When you click a row, the onRowClick gets triggered and saves the data of the selectedRow.-->
    <q-table 
      title="Todos" 
      :rows="rows" 
      :columns="columns" 
      row-key="name"
      @row-click="onRowClick" 
    />
  </q-page>
</template>

<script>
  import {ref} from "vue";
  import axios from "axios";

  export default {
    setup() {
      let rows = ref([]);
      let columns = ref([
        {
          name: "title",
          label: "Title",
          align: "left",
          field: "title",
        },
        {
          name: "completed",
          label: "Completed",
          align: "left",
          field: "completed",
        },
      ]);

      let form = ref({
        userId: 1,
        title: null,
        completed: false,
      });

      let btnLoadingState = ref(false);

      let selectedRow = ref({});
      const onRowClick = (evt, row) => {
        selectedRow.value = row;
        form.value.title = row.title;
      };

      let deleteBtnLoadingState = ref(false);

      //This function is for deleting a todo item if selected.
      const deleteTodo = () => {
        deleteBtnLoadingState.value = true;
        axios
          .delete(`https://jsonplaceholder.typicode.com/todos/${selectedRow.value.id}`)
          .then((response) => {
            if (response.status === 200) {
              rows.value = rows.value.filter(
                (row) => row.id !== selectedRow.value.id
              );
              form.value.title = null;
            }
            deleteBtnLoadingState.value = false;
          });
      };
      
      //This function is for updating the name or title of a todo item if selected.
      const updateTodo = () => {
        btnLoadingState.value = true;
        axios
          .put(`https://jsonplaceholder.typicode.com/todos/${selectedRow.value.id}`,
            {
              title: form.value.title,
            }
          )
          .then((response) => {
            if(response.status = 200) {
              let index = rows.value.findIndex(
                (row) => row.id === selectedRow.value.id
              );
              rows.value[index].title = response.data.title;
              form.value.title = null;
              selectedRow.value = {};
            }
            btnLoadingState.value = false;
          });
      };

      //This function is for adding a new todo item to the list.
      const addTodo = () => {
        btnLoadingState.value = true;
        axios
          .post("https://jsonplaceholder.typicode.com/todos", form.value)
          .then((response) => {
            if (response.status === 201) {
              rows.value.unshift(response.data);
              form.value.title = null;
            }
            btnLoadingState.value = false;
          });
      };

      //This function is only for getting reponses from a fake API for sample data.
      const getTodos = () => {
        axios
          .get("https://jsonplaceholder.typicode.com/todos")
          .then((response) => {
            rows.value = response.data;
          });
      };

      //A method that calls the getTodos
      getTodos();

      return {rows, columns, form, btnLoadingState, addTodo, selectedRow, onRowClick, updateTodo, deleteBtnLoadingState, deleteTodo};
    }
  }
</script>